/*! firebase-admin v5.2.1 */
"use strict";
/*!
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var firebase = require("./default-namespace");
var register_auth_1 = require("./auth/register-auth");
var register_messaging_1 = require("./messaging/register-messaging");
var register_storage_1 = require("./storage/register-storage");
// Register the Database service
// For historical reasons, the database code is included as minified code and registers itself
// as a side effect of requiring the file.
/* tslint:disable:no-var-requires */
require('./database/database');
/* tslint:enable:no-var-requires */
// Register the Auth service
register_auth_1.default();
// Register the Messaging service
register_messaging_1.default();
// Register the Storage service
register_storage_1.default();
module.exports = firebase;
