/*! firebase-admin v5.2.1 */
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var storage_1 = require("./storage");
var firebase = require("../default-namespace");
/**
 * Factory function that creates a new Storage service.
 *
 * @param {Object} app The app for this service.
 * @param {function(Object)} extendApp An extend function to extend the app namespace.
 *
 * @return {Storage} The Storage service for the specified app.
 */
function serviceFactory(app, extendApp) {
    return new storage_1.Storage(app);
}
/**
 * Handles app life-cycle events.
 *
 * @param {string} event The app event that is occurring.
 * @param {FirebaseApp} app The app for which the app hook is firing.
 */
var appHook = function (event, app) {
    return;
};
function default_1() {
    return firebase.INTERNAL.registerService('storage', serviceFactory, { Storage: storage_1.Storage }, appHook);
}
exports.default = default_1;
